const { BootstrapStarter } = require('@midwayjs/bootstrap');
const { Framework } = require('@midwayjs/faas');
const { asyncWrapper, start } = require('/Users/lxxyx/Desktop/ali/midway-hooks/open-source/node_modules/@midwayjs/serverless-fc-starter/dist/index.js');


const { registerFunctionToIocByConfig } = require('./registerFunction.js');
const { join } = require('path');

const picomatch = require('picomatch');
const layers = [];


let starter;
let runtime;
let inited = false;


const initializeMethod = async (initializeContext = {}) => {
  
  layers.unshift(engine => {
    engine.addRuntimeExtension({
      async beforeFunctionStart(runtime) {
        starter = new Framework();
        starter.configure({
          initializeContext,
          preloadModules: [],
          applicationAdapter: runtime
        });
        const boot = new BootstrapStarter();
        const baseDir = __dirname;

        boot.configure({
          baseDir,
        }).load(starter);

        await boot.init();
        
        registerFunctionToIocByConfig({
  "functionList": [
    {
      "functionName": "controller",
      "functionHandler": "index-controller.handler",
      "functionFilePath": "lambda/index.js",
      "argsPath": "ctx.request.body.args"
    },
    {
      "functionName": "",
      "functionHandler": "index.handler",
      "functionFilePath": "lambda/index.js",
      "argsPath": "ctx.request.body.args"
    }
  ]
}, {
          baseDir: join(__dirname, 'dist'),
          context: starter.getApplicationContext()
        });
        
        await boot.run();
      }
    });
  })
  runtime = await start({
    layers: layers,
    getHandler: getHandler
  });
  
   inited = true; 
  
};

const getHandler = (hanlderName) => {
  
    if (hanlderName === 'handler') {
      return  starter.handleInvokeWrapper('index-controller.handler'); 
    }
  
}




exports.initializer = asyncWrapper(async (...args) => {
  if (!inited) {
    await initializeMethod(...args);
  }
});


exports.handler = asyncWrapper(async (...args) => {
  if (!inited) {
    await initializeMethod();
  }
  

  const handler = getHandler('handler');
  return runtime.asyncEvent(handler)(...args);
});

